import 'package:flutter/material.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:passwordmicrointeraction/passwordmicrointeraction.dart';

///A Login form using the Password MicroInteraction.
class MyHomePage extends StatelessWidget {
  MyHomePage({Key key}) : super(key: key);
  String passwordValue;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: _buildPageContent(context: context),
    );
  }

  Widget _buildPageContent({BuildContext context}) {
    return Container(
      color: Colors.blue.shade100,
      child: ListView(
        children: <Widget>[
          SizedBox(
            height: 30.0,
          ),
          CircleAvatar(
            child: Image.asset('assets/images/lightbulb.png'),
            maxRadius: 50,
            backgroundColor: Colors.transparent,
          ),
          SizedBox(
            height: 20.0,
          ),
          _buildLoginForm(context: context),
          //   _buildSignUpLink(context),
        ],
      ),
    );
  }

  Widget _buildLoginForm({BuildContext context}) {
    return Column(
      children: <Widget>[
        PasswordMicroInteraction(
          form: Column(
            children: <Widget>[
              Column(
                mainAxisAlignment: MainAxisAlignment.center,
                children: <Widget>[
                  SizedBox(
                    height: 90.0,
                  ),
                  Container(
                    padding: EdgeInsets.symmetric(horizontal: 20.0),
                    child: TextField(
                      style: TextStyle(color: Colors.black54),
                      decoration: InputDecoration(
                          hintText: "Email address",
                          hintStyle: TextStyle(color: Colors.blue.shade200),
                          border: InputBorder.none,
                          icon: Icon(
                            Icons.email,
                            color: Colors.blue,
                          )),
                      onChanged: (emailValue) {},
                    ),
                  ),
                  Container(
                    child: Divider(
                      color: Colors.blue.shade400,
                    ),
                    padding:
                        EdgeInsets.only(left: 20.0, right: 20.0, bottom: 10.0),
                  ),
                ],
              ),
            ],
          ),
          onChanged: (passwordValue) {
            this.passwordValue = passwordValue;
          },
        ),
        SizedBox(height: 50),
        RaisedButton(
          onPressed: () {
            Fluttertoast.showToast(msg: 'Password is $passwordValue');
          },
          child: Text('Button'),
        ),
      ],
    );
  }
}
